/*Simon Says game with LCD Display.
  
*/


#include <LiquidCrystal_I2C.h>
#include<Wire.h>

char array1[] = "Simon Says!  ";
char array2[] = "Hello, Player";
char array3[] = "Lets Play   ";
char array4[] = "YOU LOSE!";


LiquidCrystal_I2C lcd(0x27, 16, 2);




int button[] = {2, 3, 4, 5}; //The four button input pins
int ledpin[] = {8, 9, 10, 11};  // LED pins
int turn = 0;  // turn counter
int buttonstate;  // button state checker`
int buttonstate1;
int randomArray[100]; //Intentionally long to store up to 100 inputs (doubtful anyone will get this far)
int inputArray[100];
int positionCounter;
int score = 0;

int tim = 400; //the value of delay time


#include <Servo.h> 
Servo doorServo;
Servo handServo;

int switch_pin = 7;               //set switch on pin 2

//motor variables
int motorThrottle=11;
int motorDirection = 13;
int motorBrake=8;

//Distance Variables
int motionPin = 0;    //motion sensor pin on analog 0
int lastDist = 0;      //to remember last distance
int currentDist = 0;   
int thresh = 100;      //Threshold for Movement


int pos = 0;
int selectedMove = 0;             //move selector
int Testmove = 0;                 //test mode: set to move number to test only one selected move 
                                  //(set to Zero to run normally i.e: roundrobbin on amm moves)



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void setup()
{


 Serial.begin(9600);
  pinMode(switch_pin, INPUT);
  doorServo.attach(12);           //set door servo on Pin 12 pwm
  handServo.attach(13);          //set hand servo on Pin 13 pwm
  doorServo.write(80);           //set door to hiding position 
  handServo.write(0);            //set hand to hiding position
  //Setup Channel B, since Channel A is reserved by door and hand servos and can't ber used at same time
  pinMode(motorDirection, OUTPUT); //Initiates Motor Channel B pin
  pinMode(motorBrake, OUTPUT); //Initiates Brake Channel B pin
  

   
  lcd.init();
  lcd.backlight();
  Serial.begin(9600);
  
  lcd.setCursor(15, 0); // set the cursor to column 15, line 0
  for (int positionCounter = 0; positionCounter < 13; positionCounter++)
  {
    lcd.scrollDisplayLeft(); //Scrolls the contents of the display one space to the left.
    lcd.print(array1[positionCounter]); // Print a message to the LCD.
    delay(tim); //wait for 250 microseconds
  }

delay(1500);
  
  lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left  corner.
  lcd.setCursor(15, 0); // set the cursor to column 15, line 1

  for (int positionCounter = 0; positionCounter < 13; positionCounter++)
  {
    lcd.scrollDisplayLeft(); //Scrolls the contents of the display one space to the left.
    lcd.print(array2[positionCounter]); // Print a message to the LCD.
    delay(tim); //wait for 250 microseconds
  }

  delay(1500);

  
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void loop()
{
  

  //When the user clicks the YES button, the game will begin.
  if (buttonstate == LOW) {

    lcd.clear();
    lcd.setCursor(15, 0); // set the cursor to column 15, line 0
    for (int positionCounter = 0; positionCounter < 12; positionCounter++)
    {
      lcd.scrollDisplayLeft(); //Scrolls the contents of the display one space to the left.-
      lcd.print(array3[positionCounter]); // Print a message to the LCD
      delay(tim); //wait for 250 microseconds
    }
delay(1500);

    lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left  corner.
   

    //This for loop will register all the LEDS as outputs
    for (int x = 0; x < 4; x++) // LED pins are outputs
    {
      pinMode(ledpin[x], OUTPUT);
    }

    //This for loop will register buttons that control LEDs as inputs and to make them do digitalWrite
    for (int x = 0; x < 4; x++)
    {
      pinMode(button[x], INPUT);  // button pins are inputs
      digitalWrite(button[x], HIGH);  // enable internal pullup; buttons start in high position; logic reversed
    }

    randomSeed(analogRead(0)); //Added to generate "more randomness" with the randomArray for the output function
    
    
      
      digitalWrite(ledpin[0], LOW);
      digitalWrite(ledpin[1], LOW);
      digitalWrite(ledpin[2], LOW);
      digitalWrite(ledpin[3], LOW);
      delay(25);
    }
    delay(1000);

    //The actual game will begin. Random LEDS will begin to genetate and be outputted to the user.
    for (int y = 0; y <= 99; y++)
    {
      //function for generating the array to be matched by the player
      digitalWrite(ledpin[0], HIGH);
      digitalWrite(ledpin[1], HIGH);
      digitalWrite(ledpin[2], HIGH);
      digitalWrite(ledpin[3], HIGH);

     
        delay(25);
      }

      digitalWrite(ledpin[0], LOW);
      digitalWrite(ledpin[1], LOW);
      digitalWrite(ledpin[2], LOW);
      digitalWrite(ledpin[3], LOW);
      delay(1000);

      for (int y = turn; y <= turn; y++)
      { //Limited by the turn variable
        Serial.println(""); //Some serial output to follow along
        lcd.print("Score: ");
        lcd.print(score);
        score++;
        Serial.print(y);
        Serial.println("");
        randomArray[y] = random(1, 5); //Assigning a random number (1-4) to the randomArray[y], y being the turn count
        for (int x = 0; x <= turn; x++)
        {
          Serial.print(randomArray[x]);

          //This for loop will output the randomly generated LEDs to the user
          for (int y = 0; y < 4; y++)
          {

            if (randomArray[x] == 1 && ledpin[y] == 8)
            { //if statements to display the stored values in the array
              digitalWrite(ledpin[y], HIGH);
              
              delay(400);
              digitalWrite(ledpin[y], LOW);
              delay(100);
            }

            if (randomArray[x] == 2 && ledpin[y] == 9)
            {
              digitalWrite(ledpin[y], HIGH);
              
              delay(400);
              digitalWrite(ledpin[y], LOW);
              delay(100);
            }

            if (randomArray[x] == 3 && ledpin[y] == 10)
            {
              digitalWrite(ledpin[y], HIGH);
              
              delay(400);
              digitalWrite(ledpin[y], LOW);
              delay(100);
            }

            if (randomArray[x] == 4 && ledpin[y] == 11)
            {
              digitalWrite(ledpin[y], HIGH);
              
              delay(400);
              digitalWrite(ledpin[y], LOW);
              delay(100);
            }
          }
        }
      }
      //Will go into the input function and check and see if user input mathced program generated LED
      input();
    }
  
  


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void input() { //Function for allowing user input and checking input against the generated array

  for (int x = 0; x <= turn;)
  { //Statement controlled by turn count

    for (int y = 0; y < 4; y++)
    {

      buttonstate = digitalRead(button[y]);

      if (buttonstate == LOW && button[y] == 2)
      { //Checking for button push
        digitalWrite(ledpin[0], HIGH);
       
        delay(200);
        digitalWrite(ledpin[0], LOW);
        inputArray[x] = 1;
        delay(250);
        Serial.print(" ");
        Serial.print(1);
        if (inputArray[x] != randomArray[x]) { //Checks value input by user and checks it against
          fail();                              //the value in the same spot on the generated array
        }//The fail function is called if it does not match
        x++;
      }
      //These if statements will first check and see which button the user clicked. Based on that, the program will 
      //check and determine if the user chose the correct button
      if (buttonstate == LOW && button[y] == 3)
      {
        digitalWrite(ledpin[1], HIGH);
        
        delay(200);
        digitalWrite(ledpin[1], LOW);
        inputArray[x] = 2;
        delay(250);
        Serial.print(" ");
        Serial.print(2);
        if (inputArray[x] != randomArray[x]) {
          fail();
        }
        x++;
      }

      if (buttonstate == LOW && button[y] == 4)
      {
        digitalWrite(ledpin[2], HIGH);
        
        delay(200);
        digitalWrite(ledpin[2], LOW);
        inputArray[x] = 3;
        delay(250);
        Serial.print(" ");
        Serial.print(3);
        if (inputArray[x] != randomArray[x]) {
          fail();
        }
        x++;
      }

      if (buttonstate == LOW && button[y] == 5)
      {
        digitalWrite(ledpin[3], HIGH);
       
        delay(200);
        digitalWrite(ledpin[3], LOW);
        inputArray[x] = 4;
        delay(250);
        Serial.print(" ");
        Serial.print(4);
        if (inputArray[x] != randomArray[x])
        {
          digitalWrite(ledpin[0], LOW);
          digitalWrite(ledpin[1], LOW);
          digitalWrite(ledpin[2], LOW);
          digitalWrite(ledpin[3], LOW);
          fail();
        }
        x++;
      }
    }
  }
  lcd.clear();
  delay(500);
  turn++; //Increments the turn count, also the last action before starting the output function over again
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void fail() { //Function used if the player fails to match the sequence

  for (int y = 0; y <= 2; y++)
  { //Flashes lights for failure

    digitalWrite(ledpin[0], HIGH);
    digitalWrite(ledpin[1], HIGH);
    digitalWrite(ledpin[2], HIGH);
    digitalWrite(ledpin[3], HIGH);
   
    delay(200);
    digitalWrite(ledpin[0], LOW);
    digitalWrite(ledpin[1], LOW);
    digitalWrite(ledpin[2], LOW);
    digitalWrite(ledpin[3], LOW);
  
    delay(200);
  }
  //Reset score to 0
  score = 0;
  lcd.clear();
  lcd.print("You Lost");
  delay(2000);
  turn = -1; //Resets turn value so the game starts over without need for a reset button

 switchofffunc();

}



   void switchofffunc() 
   {    
   //Moving door
    for(pos = 80; pos < 170; pos += 3)   
    {                                   
    doorServo.write(pos);              
    delay(15);                       
    }
   
    //Moving hand
    for(pos = 0; pos < 130; pos += 4)  
    {                                   
    handServo.write(pos);               
    delay(60);                       
    }  
    
    //hiding hand
    for(pos = 130; pos>=0; pos-=4)      
    {                                
    handServo.write(pos);               
    delay(60);                        
    } 
      
    //hiding door
    for(pos = 170; pos>=80; pos-=3)     
    {                                
    doorServo.write(pos);              
    delay(25);                      
    } 
   } 
